/*

	Functions:

	int LoadAllCursors()
	void DestroyAllCursors()



 */

#include "endeavour.h"

#include "../include/cursors/translate.xpm"
#include "../include/cursors/zoom.xpm"




int LoadAllCursors()
{
	cursor_t cursor;
	WCursor *wcursor;
	WColorStruct color;


	if(!IDC())
	    return(-1);


	/* Basic GUI standard cursors. */
        cursor = OSWLoadBasicCursor(XC_sb_h_double_arrow);
        if(cursor == 0) return(-1);
        endeavour_cursor.list_heading_resize = cursor;
            
        cursor = OSWLoadBasicCursor(XC_crosshair);
        if(cursor == 0) return(-1);
        endeavour_cursor.cross_hairs = cursor;
        
        cursor = OSWLoadBasicCursor(XC_watch);
        if(cursor == 0) return(-1);
        endeavour_cursor.working = cursor;


	/* Advanced cursors. */
	color.a = 0x00;
	color.r = 0xff;
	color.g = 0xff;
	color.b = 0xff;
	wcursor = WidgetCreateCursorFromData(
	    translate_xpm,
	    8, 8,
	    color
	);
	if(wcursor == NULL) return(-1);
	endeavour_cursor.translate = wcursor;

        wcursor = WidgetCreateCursorFromData(
            zoom_xpm,
            8, 8,
            color
        );
        if(wcursor == NULL) return(-1);
        endeavour_cursor.zoom = wcursor;



	return(0);
}



void DestroyAllCursors()
{
	if(!IDC())
	    return;


        OSWDestroyCursor(&endeavour_cursor.list_heading_resize);
        OSWDestroyCursor(&endeavour_cursor.cross_hairs);
        OSWDestroyCursor(&endeavour_cursor.working);

	WidgetDestroyCursor(&endeavour_cursor.translate);
	WidgetDestroyCursor(&endeavour_cursor.zoom);


	return;
}
