/*
                     Endeavour window default values



*/

#ifndef EDWDEFAULTS_H
#define EDWDEFAULTS_H


/*
 *	Time format defaults:
 */
#ifndef MAX_TIME_STR
    #define MAX_TIME_STR        256
#endif

/*
 *	Time format string used in listings:
 *
 *	Some compilers warn about this producing only two year
 *	digits. That's safe to ignore since we are using %c as the
 *	`preffered time string format'.
 */
#define LISTING_MTIME_FORMAT_STR	"%c"
#define LISTING_TIME_UNKNOWN_STR	"*unknown*"


/*
 *      Sizing definations, in pixels or otherwise stated:
 */
#define DEF_DIR_WIN_WIDTH       25      /* In percent. */

#define DEVREC_X_POS_START	410
#define DEVREC_ENTRY_SPACING	50

#define MIN_WIDTH               320
#define MIN_HEIGHT              240

#define DEF_WIDTH               800
#define DEF_HEIGHT              600

#define EDW_BTN_WIDTH		30
#define EDW_BTN_HEIGHT		30


#define PROMPT_HEIGHT           30      /* For all edw prompts. */

#define LIST_MARGIN		5	/* Dir and file list margins. */
#define ROW_SPACING             28

/* Dir list window sizings. */
#define DIR_ICON_WIDTH		24
#define DIR_ROUTE_WIDTH		24	/* The lines connecting each dir icon. */
#define DIR_LEVEL_INC		24	/* Dir level spacing in pixels. */

#define CHAR_WIDTH              7
#define CHAR_HEIGHT             14

#define TOOL_RIBBON_HEIGHT      40
#define FILE_HEADING_HEIGHT     20  
#define STATUS_HEIGHT           30

  
/* Width of vertical seperator between the dir and file windows. */  
#define VERT_SEP_WIDTH          5


#define WM_TITLE_HEIGHT		40	/* Best guess for WM title height. */


/*
 *      Default file window colum positions, in pixels.
 */
#define DEF_COL_NAME_POS        0
#define DEF_COL_SIZE_POS        160
#define DEF_COL_PERMISSION_POS  225
#define DEF_COL_OWNER_POS       315
#define DEF_COL_GROUP_POS       375
#define DEF_COL_DATE_POS        435



/*
 *	Endeavour window hint messages.
 *
 */
#define HINT_MESG_BACK_BTN	"Go to parent directory"
#define HINT_MESG_REFRESH_BTN	"Refresh all listings (F5)"
#define HINT_MESG_NEWFOLDER_BTN	"Create a new directory"
#define HINT_MESG_PROPERTIES_BTN	"Edit selected object's properties (ALT+ENTER)"
#define HINT_MESG_MOVE_BTN	"Move selected object(s) (F7)"
#define HINT_MESG_COPY_BTN	"Copy selected object(s) (F8)"
#define HINT_MESG_RECYCLE_BTN	"Recycle selected object(s) (DEL)"
#define HINT_MESG_NEWBROWSER_BTN	"New browser window"
#define HINT_MESG_TILE_BTN	"Tile browser windows"
#define HINT_MESG_MAPRECBIN_BTN	"Open recycle bin"

#define HINT_MESG_OUTPUT_BTN	"Show output of last execution"
#define HINT_MESG_KILL_BTN	"Kill last execution"
#define HINT_MESG_VIEW_BTN	"View selected objects"
#define HINT_MESG_EDIT_BTN	"Edit selected objects"

#define HINT_MESG_PADLOCK	"Toggles master write-protect on/off"


/*
 *	Menu codes.
 */
#define EDW_MC_NONE			0
#define EDW_MC_DIR_EXPAND_TOGGLE	100	/* Also colapses dirs. */
#define EDW_MC_FILE_EXECUTE		101	/* Execute or view object. */

#define EDW_MC_COPY			110
#define EDW_MC_MOVE			111
#define EDW_MC_RENAME			112
#define EDW_MC_RECYCLE			113
#define EDW_MC_PROPERTIES		114

#define EDW_MC_EDITOR			120	/* Text editor. */


#endif /* EDWDEFAULTS_H */
