#ifndef FASS_H
#define FASS_H


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/bitypes.h>

#ifdef __linux__
    #include <linux/limits.h>
    #include <linux/types.h>
#endif

#include "../include/os.h"


/*
 *	File association format definations:
 */
#define MAX_EXT_LEN		NAME_MAX
#define MAX_EXT_FIELD_LEN	NAME_MAX

#define EXT_DELIMITER_CHAR		'.'
#define EXT_FIELD_DELIMITER_CHAR	' '


/*
 *	List of known image file format extensions.
 *	NULL terminated.
 */
#define FASS_KNOWN_IMAGE_EXT	{ \
        "bmp", \
	"eim", \
	"gif", \
	"jpg", \
	"jpeg", \
	"pcx", \
	"pgm", \
	"png", \
	"ppm", \
	"tif", \
	"tiff", \
	"tga", \
	"xbm", \
	"xpm", \
	NULL \
}



/*
 *      File associations structure:
 */
typedef struct {

        char *ext;
        char *cmd;

} file_ass_struct;

extern file_ass_struct **file_ass;
extern int total_file_asses;


/* ******************************************************************
 *
 */
extern int ISEXTIMAGE(char *filename);
extern void FAssSubCommand(char *cmd, char *arg);

extern void FAssLoadDefaults();
extern int FAssAdd(char *ext, char *cmd);
extern void FAssDeleteAll();

extern char *FAssExtParse(char *string);
extern char *FAssGetCmdByExt(char *ext);



#endif /* FASS_H */
