#ifndef OBJECT_H
#define OBJECT_H


/*
 *      Endeavour object structure:
 */     
typedef struct {

        char *name;
        char *link_dest;    /* Destination if this is a symlink. */
 
        ino_t inode;        /* Inode. */
        umode_t mode;       /* Mode/permissions/type. */
 
        nlink_t nlink;      /* Number of hard links. */
        uid_t uid;          /* User ID of owner */
        gid_t gid;          /* Group ID of owner */
        dev_t rdevice;      /* Device type (if inode device) */
        off_t size;         /* Total size, in blocks. */
        time_t last_accessed;       /* time of last access */
        time_t last_modified;       /* time of last modification */
        time_t create_time;         /* time of last change */
        
} object_struct;





#endif /* OBJECT_H */
