/*

	Functions:

	int TimmerInitAll()
	void TimmerResetAll()
	void TimmerManageAll()


 */

#include "endeavour.h"



int TimmerInitAll()
{
	timmer[T_SGLOW_CODE].val = 0;
        timmer[T_SGLOW_CODE].max = T_SGLOW_MAX;
        timmer[T_SGLOW_CODE].i = T_SGLOW_INT;
        timmer[T_SGLOW_CODE].next = 0;

        timmer[T_MGLOW_CODE].val = 0;
        timmer[T_MGLOW_CODE].max = T_MGLOW_MAX;
        timmer[T_MGLOW_CODE].i = T_MGLOW_INT;
        timmer[T_MGLOW_CODE].next = 0;

        timmer[T_LGLOW_CODE].val = 0;
        timmer[T_LGLOW_CODE].max = T_LGLOW_MAX;
        timmer[T_LGLOW_CODE].i = T_LGLOW_INT;
        timmer[T_LGLOW_CODE].next = 0;

	return(0);
}



void TimmerResetAll()
{
	int i;

	for(i = 0; i < MAX_TIMMERS; i++)
	{
	    timmer[i].val = 0;
	    timmer[i].next = 0;
	}

	return;
}



void TimmerManageAll()
{
	int i;
	long t;

	/* Get current time. */
	t = MilliTime();

	for(i = 0; i < MAX_TIMMERS; i++)
	{
	    /* Not due for increment? */
	    if(timmer[i].next > t) continue;

	    /* Increment. */
	    timmer[i].val += 1;

	    /* Past maximum? if so need reset. */
	    if(timmer[i].val >= timmer[i].max)
	    {
		timmer[i].val = 0;
	    }

	    /* Schedual next increment time. */
	    timmer[i].next = t + timmer[i].i;
	}

	return;
}
